/*******************************************************************************
	Demonstration Plate Driver

	THE SOFTWARE IS PROVIDED \"AS-IS\" AND WITHOUT WARRANTY OF ANY KIND,
	EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
	WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

	IN NO EVENT SHALL PETER KOLLER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
	INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
	RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
	THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
	OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

	(c) COPYRIGHT 2022 PETER KOLLER.
*******************************************************************************/
#ifndef DEMOPLATECLASS_HEADER
#define DEMOPLATECLASS_HEADER

#include "RasterOut.h"

#ifdef __cplusplus

typedef struct _rasterPageInformation
{
	int lpiResolution;
	int dotmapSize;
	UINT64 xOffset;
	UINT64 yOffset;
	LONG curOffs;
} PAGEINFORMATION, *LPPAGEINFORMATION;

class DemoplateDriverClass : public RasterOutputInterface
{
	static UINT64 dpiToPixels(LONG offset, int lpiResolution, int dotmapSize);
public:
	const LPPLATEDATA EnumPlateData(int &index) override;
	HANDLE Open(LPMETACONTROL pXmlMetadata, PRENDERDATA lpRd, int PlateIndex) override;
	HANDLE OpenRasterPage(HANDLE plateHandle, LPCTSTR pDataFile, SIZE plateOffset, SIZE mapSize, int lpiResolution, int dotmapSize) override;
	LONG TranslateCoordinates(HANDLE handle, LONG value, bool bGetMeasurement) override;
	int SetPosition(HANDLE plateHandle, LPPOINT newPosition, ULONG positionFlags) override;
	bool WriteRasterData(HANDLE handle, LONG yRow, LPCVOID lpBuffer, size_t rowSize) override;
	void CloseRasterPage(HANDLE handle) override;
	void Close(HANDLE handle) override;
	DemoplateDriverClass() { _operatingmode = INTERFACE_PLATEPARALLEL | INTERFACE_AUTOPLATEFEED; }
};

#endif  /* __cplusplus */
#endif
