/*******************************************************************************
	Demonstration Plate Driver

	THE SOFTWARE IS PROVIDED \"AS-IS\" AND WITHOUT WARRANTY OF ANY KIND,
	EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
	WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

	IN NO EVENT SHALL PETER KOLLER BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
	INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
	RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
	THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
	OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

	(c) COPYRIGHT 2022 PETER KOLLER.
*******************************************************************************/
#define		PLATEDRIVER_SOURCE
#define		WIN32_LEAN_AND_MEAN
#define		DllExport   __declspec(dllexport)
#define		_WIN32_IE		0x600		//must be at least common controls & shell v6.00 (was 500 in API V3.20)
#define		WINVER			0x600
#define		_WIN32_WINNT	0x600
#define		M_ALLOW_ANIMATION			//allows the use of the Windows Animate function
#define		M_UNRESTRICTED_MEMSIZE		//allows the use of memory above 2^32 bytes
#define		LOWEST_ACCEPTABLE_VERSION	0x20000 /* Below that the DLL will not load */

#include    <windows.h>
#include    <tchar.h>
#include    <stdlib.h>
#include    <string.h>
#include    <stdio.h>
#include    "RasterOut.h"
#include    "PlateDriver.h"
#include    "DemoPlate.h"

extern "C" {
	INTERFACETYPE myInterface[1] =
	{
		0,
		INTERFACE_TYPE_DIRECT,
		0,
		_T("Demo"),
		_T("Example Direct To Plate (DTP) Driver 00.01.00"),
		_T("\xa9 2021 P.Koller, Maison Anglais. All Rights Reserved.\n\n")
		_T("THE SOFTWARE IS PROVIDED \"AS-IS\" AND WITHOUT WARRANTY OF ANY KIND, ")
		_T("EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY ")
		_T("WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.\n\n")
		_T("IN NO EVENT SHALL PETER KOLLER BE LIABLE FOR ")
		_T("ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, ")
		_T("OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, ")
		_T("WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF ")
		_T("LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE ")
		_T("OF THIS SOFTWARE.")
	};


	APIRET  APIENTRY LibraryInit(ULONG version, HINSTANCE mod, PULONG nInterfaces, PINTERFACETYPE* interfaces, PVOID mf)
	{
		ULONG   myVersion = LOWEST_ACCEPTABLE_VERSION + 1;
		if (version >= myVersion)
		{
			myModule = mod;
			myInterface[0].instance = mod;
			if (nInterfaces)
				*(nInterfaces) = 1;
			if (interfaces)
				*(interfaces) = myInterface;
			return myVersion;
		}
		return 0;
	}

	PVOID APIENTRY GetInterfaceInstance(int type, int id)
	{
		if (type == myInterface[0].type)
		{
			if (id == myInterface[0].id)
			{
				return new DemoplateDriverClass();
			}
		}
		return NULL;
	}
}